fix PATH
[build.git] / lbuild-initvm.sh
index 29d6d4b..193be78 100755 (executable)
@@ -9,6 +9,11 @@ BUILD_DIR=$(pwd)
 
 # pkgs parsing utilities
 PATH=$(dirname $0):$PATH export PATH
+
+# old guests have e.g. mount in /bin but this is no longer part of 
+# the standard PATH in recent hosts after usrmove, so let's keep it simple
+PATH=$PATH:/bin:/sbin export PATH
+
 . build.common
 
 DEFAULT_FCDISTRO=f20
@@ -190,6 +195,39 @@ function create_bridge_if_needed() {
 
 }
 
+##############################
+# return yum or debootstrap
+function package_method () {
+    fcdistro=$1; shift
+    case $fcdistro in
+       f[0-9]*|centos[0-9]*|sl[0-9]*) echo yum ;;
+       squeeze|wheezy|oneiric|precise|quantal|raring|saucy) echo debootstrap ;;
+       *) echo Unknown distro $fcdistro ;;
+    esac 
+}
+
+# return arch from debian distro and personality
+function canonical_arch () {
+    personality=$1; shift
+    fcdistro=$1; shift
+    case $(package_method $fcdistro) in
+       yum)
+           case $personality in *32) echo i386 ;; *64) echo x86_64 ;; *) echo Unknown-arch-1 ;; esac ;;
+       debootstrap)
+           case $personality in *32) echo i386 ;; *64) echo amd64 ;; *) echo Unknown-arch-2 ;; esac ;;
+       *)
+           echo Unknown-arch-3 ;;
+    esac
+}
+
+# the new test framework creates /timestamp in /vservers/<name> *before* populating it
+function almost_empty () { 
+    dir="$1"; shift ; 
+    # non existing is fine
+    [ ! -d $dir ] && return 0; 
+    # need to have at most one file
+    count=$(cd $dir; ls | wc -l); [ $count -le 1 ]; 
+}
 
 ##############################
 function check_yum_installed () {
@@ -203,92 +241,39 @@ function check_yumgroup_installed () {
 }
 
 ##############################
+function fedora_install() {
+    set -x
+    set -e
 
-function configure_fedora() {
-
-    # disable selinux in fedora
-    mkdir -p $rootfs_path/selinux
-    echo 0 > $rootfs_path/selinux/enforce
-
-    # set the hostname
-    case "$fcdistro" in 
-       f18|f2?)
-           cat <<EOF > ${rootfs_path}/etc/hostname
-$GUEST_HOSTNAME
-EOF
-           echo ;;
-       *)
-            cat <<EOF > ${rootfs_path}/etc/sysconfig/network
-NETWORKING=yes
-HOSTNAME=$GUEST_HOSTNAME
-EOF
-            # set minimal hosts
-           cat <<EOF > $rootfs_path/etc/hosts
-127.0.0.1 localhost $GUEST_HOSTNAME
-EOF
-           echo ;;
-    esac
-
-    dev_path="${rootfs_path}/dev"
-    rm -rf $dev_path
-    mkdir -p $dev_path
-    mknod -m 666 ${dev_path}/null c 1 3
-    mknod -m 666 ${dev_path}/zero c 1 5
-    mknod -m 666 ${dev_path}/random c 1 8
-    mknod -m 666 ${dev_path}/urandom c 1 9
-    mkdir -m 755 ${dev_path}/pts
-    mkdir -m 1777 ${dev_path}/shm
-    mknod -m 666 ${dev_path}/tty c 5 0
-    mknod -m 666 ${dev_path}/tty0 c 4 0
-    mknod -m 666 ${dev_path}/tty1 c 4 1
-    mknod -m 666 ${dev_path}/tty2 c 4 2
-    mknod -m 666 ${dev_path}/tty3 c 4 3
-    mknod -m 666 ${dev_path}/tty4 c 4 4
-    mknod -m 600 ${dev_path}/console c 5 1
-    mknod -m 666 ${dev_path}/full c 1 7
-    mknod -m 600 ${dev_path}/initctl p
-    mknod -m 666 ${dev_path}/ptmx c 5 2
-
-    #echo "setting root passwd to $root_password"
-    #echo "root:$root_password" | chroot $rootfs_path chpasswd
+    mkdir -p /var/lock/subsys/
+    (
+        flock -n -x 200 || { echo "Cache repository is busy." ; return 1 ; }
 
-    return 0
-}
+        if [ ! -e "$cache/rootfs" ]; then
+            echo "Getting cache download in $cache/rootfs ... "
+            fedora_download || { echo "Failed to download 'fedora base'"; return 1; }
+        else
+            echo "Updating cache $cache/rootfs ..."
+           if ! yum --installroot $cache/rootfs -y --nogpgcheck update ; then
+                echo "Failed to update 'fedora base', continuing with last known good cache"
+            else
+                echo "Update finished"
+            fi
+        fi
 
-function configure_fedora_init() {
+        echo "Copy $cache/rootfs to $rootfs_path ... "
+       mkdir -p $rootfs_path
+       rsync -a $cache/rootfs/ $rootfs_path/
+       
+        return 0
 
-    sed -i 's|.sbin.start_udev||' ${rootfs_path}/etc/rc.sysinit
-    sed -i 's|.sbin.start_udev||' ${rootfs_path}/etc/rc.d/rc.sysinit
-    # don't mount devpts, for pete's sake
-    sed -i 's/^.*dev.pts.*$/#\0/' ${rootfs_path}/etc/rc.sysinit
-    sed -i 's/^.*dev.pts.*$/#\0/' ${rootfs_path}/etc/rc.d/rc.sysinit
-    chroot ${rootfs_path} /sbin/chkconfig udev-post off
-    chroot ${rootfs_path} /sbin/chkconfig network on
-}
+        ) 200>/var/lock/subsys/lxc
 
-# this code of course is for guests that do run on systemd
-function configure_fedora_systemd() {
-    # so ignore if we can't find /etc/systemd at all 
-    [ -d ${rootfs_path}/etc/systemd ] || return 0
-    # otherwise let's proceed
-    ln -sf /lib/systemd/system/multi-user.target ${rootfs_path}/etc/systemd/system/default.target
-    touch ${rootfs_path}/etc/fstab
-    ln -sf /dev/null ${rootfs_path}/etc/systemd/system/udev.service
-# Thierry - Feb 2013
-# this was intended for f16 initially, in order to enable getty that otherwise would not start
-# having a getty running is helpful only if ssh won't start though, and we see a correlation between
-# VM's that refuse to lxc-stop and VM's that run crazy getty's
-# so, turning getty off for now instead
-#   #dependency on a device unit fails it specially that we disabled udev
-#    sed -i 's/After=dev-%i.device/After=/' ${rootfs_path}/lib/systemd/system/getty\@.service
-    ln -sf /dev/null ${rootfs_path}/etc/systemd/system/"getty@.service"
-    rm -f ${rootfs_path}/etc/systemd/system/getty.target.wants/*service || :
-# can't seem to handle this one with systemctl
-    chroot ${rootfs_path} /sbin/chkconfig network on
+    return $?
 }
 
-function download_fedora() {
-set -x
+function fedora_download() {
+    set -x
     # check the mini fedora was not already downloaded
     INSTALL_ROOT=$cache/partial
     echo $INSTALL_ROOT
@@ -296,11 +281,7 @@ set -x
     # download a mini fedora into a cache
     echo "Downloading fedora minimal ..."
 
-    mkdir -p $INSTALL_ROOT
-    if [ $? -ne 0 ]; then
-        echo "Failed to create '$INSTALL_ROOT' directory"
-        return 1
-    fi
+    mkdir -p $INSTALL_ROOT || { echo "Failed to create '$INSTALL_ROOT' directory" ; return 1; }
 
     mkdir -p $INSTALL_ROOT/etc/yum.repos.d   
     mkdir -p $INSTALL_ROOT/dev
@@ -312,8 +293,7 @@ set -x
     cp /etc/yum.repos.d/fedora* $INSTALL_ROOT/etc/yum.repos.d/
 
     # append fedora repo files with desired $release and $basearch
-    for f in $INSTALL_ROOT/etc/yum.repos.d/*
-    do
+    for f in $INSTALL_ROOT/etc/yum.repos.d/* ; do
       sed -i "s/\$basearch/$arch/g; s/\$releasever/$release/g;" $f
     done 
 
@@ -351,12 +331,7 @@ set -x
     YUM="yum --installroot=$INSTALL_ROOT --nogpgcheck -y"
     PKG_LIST="yum initscripts passwd rsyslog vim-minimal dhclient chkconfig rootfiles policycoreutils openssh-server openssh-clients"
     echo "$YUM install $PKG_LIST"
-    $YUM install $PKG_LIST
-
-    if [ $? -ne 0 ]; then
-        echo "Failed to download the rootfs, aborting."
-        return 1
-    fi
+    $YUM install $PKG_LIST || { echo "Failed to download rootfs, aborting." ; return 1; }
 
     mv "$INSTALL_ROOT" "$cache/rootfs"
     echo "Download complete."
@@ -364,69 +339,109 @@ set -x
     return 0
 }
 
+##############################
+function fedora_configure() {
 
-function copy_fedora() {
-set -x
-    # make a local copy of the minifedora
-    echo -n "Copying rootfs to $rootfs_path ..."
-    mkdir -p $rootfs_path
-    rsync -a $cache/rootfs/ $rootfs_path/
-    return 0
-}
-
+    set -x
+    set -e
 
-function update_fedora() {
-set -x
-    YUM="yum --installroot $cache/rootfs -y --nogpgcheck"
-    $YUM update
-}
+    # disable selinux in fedora
+    mkdir -p $rootfs_path/selinux
+    echo 0 > $rootfs_path/selinux/enforce
 
+    # set the hostname
+    case "$fcdistro" in 
+       f18|f2?)
+           cat <<EOF > ${rootfs_path}/etc/hostname
+$GUEST_HOSTNAME
+EOF
+           echo ;;
+       *)
+            cat <<EOF > ${rootfs_path}/etc/sysconfig/network
+NETWORKING=yes
+HOSTNAME=$GUEST_HOSTNAME
+EOF
+            # set minimal hosts
+           cat <<EOF > $rootfs_path/etc/hosts
+127.0.0.1 localhost $GUEST_HOSTNAME
+EOF
+           echo ;;
+    esac
 
-function install_fedora() {
-    set -x
+    dev_path="${rootfs_path}/dev"
+    rm -rf $dev_path
+    mkdir -p $dev_path
+    mknod -m 666 ${dev_path}/null c 1 3
+    mknod -m 666 ${dev_path}/zero c 1 5
+    mknod -m 666 ${dev_path}/random c 1 8
+    mknod -m 666 ${dev_path}/urandom c 1 9
+    mkdir -m 755 ${dev_path}/pts
+    mkdir -m 1777 ${dev_path}/shm
+    mknod -m 666 ${dev_path}/tty c 5 0
+    mknod -m 666 ${dev_path}/tty0 c 4 0
+    mknod -m 666 ${dev_path}/tty1 c 4 1
+    mknod -m 666 ${dev_path}/tty2 c 4 2
+    mknod -m 666 ${dev_path}/tty3 c 4 3
+    mknod -m 666 ${dev_path}/tty4 c 4 4
+    mknod -m 600 ${dev_path}/console c 5 1
+    mknod -m 666 ${dev_path}/full c 1 7
+    mknod -m 600 ${dev_path}/initctl p
+    mknod -m 666 ${dev_path}/ptmx c 5 2
 
-    mkdir -p /var/lock/subsys/
-    (
-        flock -n -x 200
-        if [ $? -ne 0 ]; then
-            echo "Cache repository is busy."
-            return 1
-        fi
+    #echo "setting root passwd to $root_password"
+    #echo "root:$root_password" | chroot $rootfs_path chpasswd
 
-        echo "Checking cache download in $cache/rootfs ... "
-        if [ ! -e "$cache/rootfs" ]; then
-            download_fedora
-            if [ $? -ne 0 ]; then
-                echo "Failed to download 'fedora base'"
-                return 1
-            fi
-        else
-            echo "Cache found. Updating..."
-            update_fedora
-            if [ $? -ne 0 ]; then
-                echo "Failed to update 'fedora base', continuing with last known good cache"
-            else
-                echo "Update finished"
-            fi
-        fi
+    if [ "$(echo $fcdistro | cut -d"f" -f2)" -le "14" ]; then
+       fedora_configure_init
+    else
+       fedora_configure_systemd
+    fi
 
-        echo "Copy $cache/rootfs to $rootfs_path ... "
-        copy_fedora
-        if [ $? -ne 0 ]; then
-            echo "Failed to copy rootfs"
-            return 1
-        fi
+    guest_ifcfg=${rootfs_path}/etc/sysconfig/network-scripts/ifcfg-$VIF_GUEST
+    ( [ -n "$BUILD_MODE" ] && write_guest_ifcfg_build || write_guest_ifcfg_test ) > $guest_ifcfg
 
-        return 0
+    fedora_configure_yum $lxc $fcdistro $pldistro
 
-        ) 200>/var/lock/subsys/lxc
+    return 0
+}
 
-    return $?
+function fedora_configure_init() {
+    set -e
+    set -x
+    sed -i 's|.sbin.start_udev||' ${rootfs_path}/etc/rc.sysinit
+    sed -i 's|.sbin.start_udev||' ${rootfs_path}/etc/rc.d/rc.sysinit
+    # don't mount devpts, for pete's sake
+    sed -i 's/^.*dev.pts.*$/#\0/' ${rootfs_path}/etc/rc.sysinit
+    sed -i 's/^.*dev.pts.*$/#\0/' ${rootfs_path}/etc/rc.d/rc.sysinit
+    chroot ${rootfs_path} chkconfig udev-post off
+    chroot ${rootfs_path} chkconfig network on
 }
 
+# this code of course is for guests that do run on systemd
+function fedora_configure_systemd() {
+    set -e
+    set -x
+    # so ignore if we can't find /etc/systemd at all 
+    [ -d ${rootfs_path}/etc/systemd ] || return 0
+    # otherwise let's proceed
+    ln -sf /lib/systemd/system/multi-user.target ${rootfs_path}/etc/systemd/system/default.target
+    touch ${rootfs_path}/etc/fstab
+    ln -sf /dev/null ${rootfs_path}/etc/systemd/system/udev.service
+# Thierry - Feb 2013
+# this was intended for f16 initially, in order to enable getty that otherwise would not start
+# having a getty running is helpful only if ssh won't start though, and we see a correlation between
+# VM's that refuse to lxc-stop and VM's that run crazy getty's
+# so, turning getty off for now instead
+#   #dependency on a device unit fails it specially that we disabled udev
+#    sed -i 's/After=dev-%i.device/After=/' ${rootfs_path}/lib/systemd/system/getty\@.service
+    ln -sf /dev/null ${rootfs_path}/etc/systemd/system/"getty@.service"
+    rm -f ${rootfs_path}/etc/systemd/system/getty.target.wants/*service || :
+# can't seem to handle this one with systemctl
+    chroot ${rootfs_path} chkconfig network on
+}
 
-# overwrite lxc's internal yum config
-function configure_yum_in_lxc () {
+# overwrite container yum config
+function fedora_configure_yum () {
     set -x 
     set -e 
     trap failure ERR INT
@@ -435,6 +450,9 @@ function configure_yum_in_lxc () {
     fcdistro=$1; shift
     pldistro=$1; shift
 
+    # rpm --rebuilddb
+    chroot $rootfs_path rpm --rebuilddb
+
     echo "Initializing yum.repos.d in $lxc"
     rm -f $rootfs_path/etc/yum.repos.d/*
 
@@ -479,39 +497,50 @@ EOF
     fi
 }    
 
-# return yum or debootstrap
-function package_method () {
+##############################
+# need to specify the right mirror for debian variants like ubuntu and the like
+function debian_mirror () {
     fcdistro=$1; shift
     case $fcdistro in
-       f[0-9]*|centos[0-9]*|sl[0-9]*) echo yum ;;
-       squeeze|wheezy|oneiric|precise|quantal|raring|saucy) echo debootstrap ;;
-       *) echo Unknown distro $fcdistro ;;
-    esac 
+       squeeze|wheezy) 
+           echo http://ftp2.fr.debian.org/debian/ ;;
+       oneiric|precise|quantal|raring|saucy) 
+           echo http://mir1.ovh.net/ubuntu/ubuntu/ ;;
+       *) echo unknown distro $fcdistro; exit 1;;
+    esac
 }
 
-# return arch from debian distro and personality
-function canonical_arch () {
-    personality=$1; shift
-    fcdistro=$1; shift
-    case $(package_method $fcdistro) in
-       yum)
-           case $personality in *32) echo i386 ;; *64) echo x86_64 ;; *) echo Unknown-arch-1 ;; esac ;;
-       debootstrap)
-           case $personality in *32) echo i386 ;; *64) echo amd64 ;; *) echo Unknown-arch-2 ;; esac ;;
-       *)
-           echo Unknown-arch-3 ;;
-    esac
+function debian_install () {
+    set -e
+    set -x
+    mkdir -p $rootfs_path
+    arch=$(canonical_arch $personality $fcdistro)
+    mirror=$(debian_mirror $fcdistro)
+    debootstrap --arch $arch $fcdistro $rootfs_path $mirror
 }
 
-# the new test framework creates /timestamp in /vservers/<name> *before* populating it
-function almost_empty () { 
-    dir="$1"; shift ; 
-    # non existing is fine
-    [ ! -d $dir ] && return 0; 
-    # need to have at most one file
-    count=$(cd $dir; ls | wc -l); [ $count -le 1 ]; 
+function debian_configure () {
+    guest_interfaces=${rootfs_path}/etc/network/interfaces
+    ( [ -n "$BUILD_MODE" ] && write_guest_interfaces_build || write_guest_interfaces_test ) > $guest_interfaces
+}
+
+function write_guest_interfaces_build () {
+    cat <<EOF
+auto $VIF_GUEST
+iface $VIF_GUEST inet dhcp
+EOF
 }
 
+function write_guest_interfaces_test () {
+    cat <<EOF
+auto $VIF_GUEST
+iface $VIF_GUEST
+    address $IP
+    netmask $NETMASK
+    gateway $GATEWAY
+EOF
+}
+##############################
 function setup_lxc() {
 
     set -x
@@ -528,17 +557,12 @@ function setup_lxc() {
     pkg_method=$(package_method $fcdistro)
     case $pkg_method in
        yum)
-           install_fedora || { echo "failed to install fedora"; exit 1 ; }
-           configure_fedora || { echo "failed to configure fedora for a container"; exit 1 ; }
-           if [ "$(echo $fcdistro | cut -d"f" -f2)" -le "14" ]; then
-               configure_fedora_init
-           else
-               configure_fedora_systemd
-           fi
+           fedora_install || { echo "failed to install fedora root image"; exit 1 ; }
+           fedora_configure || { echo "failed to configure fedora for a container"; exit 1 ; }
            ;;
        debootstrap)
-           echo "$COMMAND: no support for debootstrap-based systems - yet"
-           exit 1
+           debian_install || { echo "failed to install debian/ubuntu root image"; exit 1 ; }
+           debian_configure || { echo "failed to configure debian/ubuntu for a container"; exit 1 ; }
            ;;
        *)
            echo "$COMMAND:: unknown package_method - exiting"
@@ -546,11 +570,6 @@ function setup_lxc() {
            ;;
     esac
 
-    # rpm --rebuilddb
-    chroot $rootfs_path /bin/rpm --rebuilddb
-
-    configure_yum_in_lxc $lxc $fcdistro $pldistro
-
     # Enable cgroup -- xxx -- is this really useful ?
     mkdir $rootfs_path/cgroup
     
@@ -564,17 +583,10 @@ function setup_lxc() {
     cat /root/.ssh/id_rsa.pub >> $rootfs_path/root/.ssh/authorized_keys
     
     config_xml=$config_path/"lxc.xml"
-    guest_ifcfg=${rootfs_path}/etc/sysconfig/network-scripts/ifcfg-$VIF_GUEST
-    if [ -n "$BUILD_MODE" ] ; then
-       write_lxc_xml_build $lxc > $config_xml
-       write_guest_ifcfg_build > $guest_ifcfg
-    else
-       write_lxc_xml_test $lxc > $config_xml
-       write_guest_ifcfg_test > $guest_ifcfg
-    fi
+    ( [ -n "$BUILD_MODE" ] && write_lxc_xml_build $lxc || write_lxc_xml_test $lxc ) > $config_xml
     
     # define lxc container for libvirt
-    virsh -c lxc:// define $config_xml
+    virsh -c lxc:/// define $config_xml
 
     return 0
 }
@@ -604,7 +616,7 @@ function write_lxc_xml_test () {
       <target dir='/'/>
     </filesystem>
     <interface type="bridge">
-      <source bridge="$BRIDGE_IF"/>
+      <source bridge="$PUBLIC_BRIDGE"/>
       <target dev='$VIF_HOST'/>
     </interface>
     <console type='pty' />
@@ -612,7 +624,7 @@ function write_lxc_xml_test () {
   <network>
     <name>host-bridge</name>
     <forward mode="bridge"/>
-    <bridge name="$BRIDGE_IF"/>
+    <bridge name="$PUBLIC_BRIDGE"/>
   </network>
 </domain>
 EOF
@@ -697,27 +709,35 @@ function devel_or_vtest_tools () {
     ### install individual packages, then groups
     # get target arch - use uname -i here (we want either x86_64 or i386)
    
-    lxc_arch=$(chroot $rootfs_path /bin/uname -i)
+    lxc_arch=$(chroot $rootfs_path uname -i)
     # on debian systems we get arch through the 'arch' command
-    [ "$lxc_arch" = "unknown" ] && lxc_arch=$(chroot $rootfs_path /bin/arch)
+    [ "$lxc_arch" = "unknown" ] && lxc_arch=$(chroot $rootfs_path arch)
 
     packages=$(pl_getPackages -a $lxc_arch $fcdistro $pldistro $pkgsfile)
     groups=$(pl_getGroups -a $lxc_arch $fcdistro $pldistro $pkgsfile)
 
     case "$pkg_method" in
        yum)
-           [ -n "$packages" ] && chroot $rootfs_path /usr/bin/yum -y install $packages
+           [ -n "$packages" ] && chroot $rootfs_path yum -y install $packages
            for group_plus in $groups; do
                group=$(echo $group_plus | sed -e "s,+++, ,g")
-               chroot $rootfs_path /usr/bin/yum -y groupinstall "$group"
+               chroot $rootfs_path yum -y groupinstall "$group"
            done
            # store current rpm list in /init-lxc.rpms in case we need to check the contents
-           chroot $rootfs_path /bin/rpm -aq > $rootfs_path/init-lxc.rpms
+           chroot $rootfs_path rpm -aq > $rootfs_path/init-lxc.rpms
            ;;
        debootstrap)
-           chroot $rootfs_path /usr/bin/apt-get update
-           for package in $packages ; do 
-               chroot $rootfs_path  /usr/bin/apt-get install -y $package 
+           chroot $rootfs_path apt-get update
+           for package in $packages ; do
+               # close stdin in an attempt to avoid this hanging
+               # xxx also we ignore result for now, not sure if the kind of errors like below
+               # truly is serious or not
+#Setting up at (3.1.13-2ubuntu2) ...
+#initctl: Unable to connect to Upstart: Failed to connect to socket /com/ubuntu/upstart: Connection refused
+#initctl: Unable to connect to Upstart: Failed to connect to socket /com/ubuntu/upstart: Connection refused
+#start: Unable to connect to Upstart: Failed to connect to socket /com/ubuntu/upstart: Connection refused
+
+               chroot $rootfs_path apt-get install -y $package < /dev/null || :
            done
            ### xxx todo install groups with apt..
            ;;
@@ -729,6 +749,17 @@ function devel_or_vtest_tools () {
     return 0
 }
 
+# would be much simpler if enter-lxc-namespace was looking along a PATH...
+function bin_in_container () {
+    binary=$1; shift
+    lxc=$1; shift
+
+    for path in /sbin /bin /usr/bin /usr/sbin; do
+       [ -f $rootfs_path/$path/$binary ] && { echo $path/$binary; return; }
+    done
+    echo bin_in_container_cannot_find_$binary
+}
+
 function post_install () {
     lxc=$1; shift 
     personality=$1; shift
@@ -736,7 +767,7 @@ function post_install () {
        post_install_build $lxc $personality
        lxc_start $lxc
        # manually run dhclient in guest - somehow this network won't start on its own
-       virsh lxc-enter-namespace $lxc /usr/sbin/dhclient $VIF_GUEST
+       virsh -c lxc:/// lxc-enter-namespace $lxc $(bin_in_container dhclient $lxc) $VIF_GUEST
     else
        post_install_myplc $lxc $personality
        lxc_start $lxc
@@ -757,7 +788,7 @@ function post_install_build () {
 
 ### From myplc-devel-native.spec
 # be careful to backslash $ in this, otherwise it's the root context that's going to do the evaluation
-    cat << EOF | chroot $rootfs_path /bin/bash -x
+    cat << EOF | chroot $rootfs_path bash -x
     # set up /dev/loop* in lxc
     for i in \$(seq 0 255) ; do
        /bin/mknod -m 640 /dev/loop\$i b 7 \$i
@@ -815,7 +846,7 @@ function post_install_myplc  () {
     personality=$1; shift
 
 # be careful to backslash $ in this, otherwise it's the root context that's going to do the evaluation
-    cat << EOF | chroot $rootfs_path /bin/bash -x
+    cat << EOF | chroot $rootfs_path bash -x
 
     # create /etc/sysconfig/network if missing
     [ -f /etc/sysconfig/network ] || /bin/echo NETWORKING=yes > /etc/sysconfig/network
@@ -845,7 +876,7 @@ function lxc_start() {
 
     lxc=$1; shift
   
-    virsh -c lxc:// start $lxc
+    virsh -c lxc:/// start $lxc
   
     return 0
 }
@@ -989,8 +1020,6 @@ function main () {
        NETMASK=$(masklen_to_netmask $PRIVATE_MASKLEN)
        GATEWAY=$PRIVATE_GATEWAY
        VIF_HOST="i$byte"
-       BRIDGE_MODE="nat"
-       BRIDGE_IF="$PRIVATE_BRIDGE"
     else
         [[ -z "GUEST_HOSTNAME" ]] && usage
        
@@ -1002,8 +1031,6 @@ function main () {
         NETMASK=$(masklen_to_netmask $MASKLEN)
         GATEWAY=$(ip route show | grep default | awk '{print $3}')
         VIF_HOST="i$(echo $GUEST_HOSTNAME | cut -d. -f1)"
-       BRIDGE_MODE="bridge"
-       BRIDGE_IF="PUBLIC_BRIDGE"
     fi
 
     echo "the IP address of container $lxc is $IP, host virtual interface is $VIF_HOST"
@@ -1020,7 +1047,7 @@ function main () {
     # bacause /var/lib/lxc/$lxc is already created while putting $lxc.timestamp
     [ -d $rootfs_path ] && \
        { echo "container $lxc already exists in filesystem - exiting" ; exit 1 ; }
-    virsh --connect lxc:// domuuid $lxc >& /dev/null && \
+    virsh -c lxc:/// domuuid $lxc >& /dev/null && \
        { echo "container $lxc already exists in libvirt - exiting" ; exit 1 ; }
 
     setup_lxc $lxc $fcdistro $pldistro $personality